/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

/*===========================================
	Malaysis Laser Payslip DateOfPayment
============================================*/
BEGIN
declare newGeneratedIndex char(30);

/* SystemRptComp */
IF NOT EXISTS (SELECT * FROM SystemRptComp WHERE SysRptId='Payslip - Laser' and SysRptCompName='DateOfPayment_wwDBDateTimePicker') THEN
INSERT INTO SystemRptComp (SysRptId, SysRptCompName, SysRptCompDesc, SysRptCompType, IsRptKey,RptkeyIndex)
VALUES ('Payslip - Laser','DateOfPayment_wwDBDateTimePicker','Date of Payment','Date',0,NULL)
END IF;

/* RptCompConfig */
IF NOT EXISTS (SELECT * FROM RptCompConfig WHERE RptCompSysId='Sys_127') THEN
INSERT INTO RptCompConfig (RptCompSysId, RptConfigID, SysRptId, SysRptCompName)
VALUES ('Sys_127','_Payslip - Laser','Payslip - Laser','DateOfPayment_wwDBDateTimePicker')
END IF;

/* RptCompItemConfig */
IF NOT EXISTS (SELECT * FROM RptCompItemConfig WHERE RptCompSysId='Sys_127' AND RptCompItemSysID = 1) THEN
INSERT INTO RptCompItemConfig (RptCompSysId, RptCompItemSysID, ItemValue)
VALUES ('Sys_127','1','1899-12-30')
END IF;

/* Add values for user-defined configuration */ 
RptConfigConsoLoop: FOR RptConfigConso AS Scroll Cursor FOR 
   SELECT RptConfigId AS OUT_RptConfigId,SysRptId AS OUT_SysRptId FROM RptConfig 
   WHERE SysRptId in ('Payslip - Laser') and Substr(RptConfigId,1,1) <> '_'
   DO  
	  if not exists(select * from RptCompConfig where RptConfigId = OUT_RptConfigId and SysRptCompName = 'DateOfPayment_wwDBDateTimePicker') then
	      set newGeneratedIndex = FGetNewSGSPGeneratedIndex('RptCompConfig');
		  
	      insert into RptCompConfig(RptCompSysId,RptConfigId,SysRptId,SysRptCompName)
	      values(newGeneratedIndex,OUT_RptConfigId,OUT_SysRptId,'DateOfPayment_wwDBDateTimePicker');
		  
		  if not exists(select * from RptCompItemConfig where RptCompSysId = newGeneratedIndex and RptCompItemSysId = 1) then
	          insert into RptCompItemConfig(RptCompSysId,RptCompItemSysId,ItemValue)
	          values(newGeneratedIndex,'1','1899-12-30');
	      end if;
	  end if;  	  	  
   END FOR; 
END;

/*===========================================
	Malaysis Laser Payslip Language
============================================*/
BEGIN
declare newGeneratedIndex char(30);
/* SystemRptComp */
IF NOT EXISTS (SELECT * FROM SystemRptComp WHERE SysRptId='Payslip - Laser' and SysRptCompName='Language_ComboBox') THEN
INSERT INTO SystemRptComp (SysRptId, SysRptCompName, SysRptCompDesc, SysRptCompType, IsRptKey,RptkeyIndex)
VALUES ('Payslip - Laser','Language_ComboBox','Language','ItemIndex',0,NULL)
END IF;

/* RptCompConfig */
IF NOT EXISTS (SELECT * FROM RptCompConfig WHERE RptCompSysId='Sys_126' ) THEN
INSERT INTO RptCompConfig (RptCompSysId, RptConfigID, SysRptId, SysRptCompName)
VALUES ('Sys_126','_Payslip - Laser','Payslip - Laser','Language_ComboBox')
END IF;

/* RptCompItemConfig */
IF NOT EXISTS (SELECT * FROM RptCompItemConfig WHERE RptCompSysId='Sys_126' AND RptCompItemSysID = 1) THEN
INSERT INTO RptCompItemConfig (RptCompSysId, RptCompItemSysID, ItemValue)
VALUES ('Sys_126','1','English')
END IF;

/* Add values for user-defined configuration */ 
RptConfigConsoLoop: FOR RptConfigConso AS Scroll Cursor FOR 
   SELECT RptConfigId AS OUT_RptConfigId,SysRptId AS OUT_SysRptId FROM RptConfig 
   WHERE SysRptId in ('Payslip - Laser') and Substr(RptConfigId,1,1) <> '_'
   DO  
	  if not exists(select * from RptCompConfig where RptConfigId = OUT_RptConfigId and SysRptCompName = 'Language_ComboBox') then
	      set newGeneratedIndex = FGetNewSGSPGeneratedIndex('RptCompConfig');
		  
	      insert into RptCompConfig(RptCompSysId,RptConfigId,SysRptId,SysRptCompName)
	      values(newGeneratedIndex,OUT_RptConfigId,OUT_SysRptId,'Language_ComboBox');
		  
		  if not exists(select * from RptCompItemConfig where RptCompSysId = newGeneratedIndex and RptCompItemSysId = 1) then
	          insert into RptCompItemConfig(RptCompSysId,RptCompItemSysId,ItemValue)
	          values(newGeneratedIndex,'1','English');
	      end if;
	  end if;  	  	  
   END FOR; 
END;
/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/