/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

/*-----------------------------------------------------------------------------------------------------------
	SS rate with effective from 1 June 2020
-----------------------------------------------------------------------------------------------------------*/
if not exists(select * from CPFPolicy where CPFPolicyId = 'SSYr2020Jun') then
	Insert into CPFPolicy(CPFPolicyId,CPFGovernment,CPFPolicyDesc) Values('SSYr2020Jun',1,'Social Security Fund Employer 5%, Employee 5% wef June 1, 2020');

	if not exists(select * from CPFTableCode where CPFTableCodeId = '0620SS') then
		Insert into CPFTableCode(CPFTableCodeId,CPFResidenceTypeId,CPFSchemeId,CPFTableDesc,CPFPeriodCapping,CPFLessThanCapping,CPFGreaterThanCapping) Values('0620SS','Local','SS','Social Security Fund Employer 5%, Employee 5% wef June 1, 2020',0,15000,1650);
		Insert into CPFPolicyMember(CPFPolicyId,CPFTableCodeId) Values('SSYr2020Jun','0620SS');
	end if;

	/*-----------------------------------------------------------------------------------------------------------
		Local
	-----------------------------------------------------------------------------------------------------------*/
	if not exists(select * from Formula where Locate(FormulaId,'0620SS') = 1 and FormulaCategory='PFFormula1') then
		Insert into Formula(FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('0620SSOA0$0ER',1,0,0,'PFFormula1','ER','T2','','','',0,0);
		Insert into Formula(FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('0620SSOA0$0EE',1,0,0,'PFFormula1','EE','T2','','','',0,0);
		Insert into Formula(FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('0620SSAA0$0ER',1,0,0,'PFFormula1','ER','T3','','','',0,0);
		Insert into Formula(FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('0620SSAA0$0EE',1,0,0,'PFFormula1','EE','T3','','','',0,0);
		Insert into FormulaRange(FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('0620SSOA0$0ER',1,0,0,'@MAX( @ROUND((C1 / 100) * K1,2), C2 );',5,750,0,0,0,'SSWage','','','','','','','','','','R2D','SSWage','','','' ,'','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange(FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('0620SSOA0$0EE',1,0,0,'@MAX( @ROUND((C1 / 100) * K1,2), C2 );',5,750,0,0,0,'SSWage','','','','','','','','','','R2D','SSWage','','','' ,'','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange(FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('0620SSAA0$0ER',1,0,0,'C1;',0,0,0,0,0,'SSWage','','','','','','','','','','R2D','SSWage','','','' ,'','','','','','','','','','','','','','','','','','','','');
		Insert into FormulaRange(FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10) Values('0620SSAA0$0EE',1,0,0,'C1;',0,0,0,0,0,'SSWage','','','','','','','','','','R2D','SSWage','','','' ,'','','','','','','','','','','','','','','','','','','','');
		Insert into CPFTableComponent(CPFTableCodeId,MinSalary,MinCPFAge,EEOrdCPFFormula,EROrdCPFFormula,MaxSalary,MaxCPFAge,EEAddCPFFormula,ERAddCPFFormula) Values('0620SS',0,0,'0620SSOA0$0EE','0620SSOA0$0ER',9999999,99,'0620SSAA0$0EE','0620SSAA0$0ER');
	end if;
	
	/* Insert Progression if current progression's effective date is earlier than 2020-06-01 */
	Insert into MandatoryContributeProg (EmployeeSysId, 
	MandContriCareerId, 
	MandContriEffDate,
	MandContriPolicyId,
	MandContriSchemeId,
	MandContriRemarks,
	MandContriCurrent,
	ManContriActSchemeId
	)
	Select CurProg.EmployeeSysId, 
	'None',
	'2020-06-01', 
	'SSYr2020Jun',
	'SS',
	'',
	0,
	''	
	From PayEmployee PE join MandatoryContributeProg CurProg
	On PE.EmployeeSysId = CurProg.EmployeeSysId
	Left Join MandatoryContributeProg NewProg ON CurProg.EmployeeSysId = NewProg.EmployeeSysId and CurProg.ManContriActSchemeId = NewProg.ManContriActSchemeId 
	     and NewProg.MandContriEffDate = '2020-06-01'
	Where CurProg.MandContriCurrent = 1 and CurProg.MandContriEffDate < '2020-06-01' and CurProg.MandContriSchemeId = 'SS'
	And NewProg.EmployeeSysId is null
	And (PE.LastPayDate = '1899-12-30' Or PE.LastPayDate >= '2020-06-01');
	
	/* Update progression if progression's effective date is equal or greater than 2020-06-01, scheme is SS & policy is SSYr2020Mar */
	Update MandatoryContributeProg
	Set MandContriPolicyId = 'SSYr2020Jun'
	Where MandContriEffDate >= '2020-06-01' 
	AND MandContriPolicyId = 'SSYr2020Mar' And MandContriSchemeId = 'SS';
	
	/*-----------------------------------------------------------------------------------------------------------
		Pay Details Default
	-----------------------------------------------------------------------------------------------------------*/
	Update SubRegistry Set ShortStringAttr= 'SSYr2020Jun'
	Where RegistryId='PaySetupData' And SubRegistryId='SSPolicy';

end if;

/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/